<?php

error_reporting(E_ALL);
ini_set("display_errors",1);

include "../vendor/autoload.php";
include "lib/errataStorageLib.php";

use setasign\Fpdi\Fpdi;

/**
 * Split all of the pages from a larger PDF file into single-page PDF files.
 *
 * @param string $filename The filename of the PDF to split
 * @param string $directory The output directory for the new PDF files
 *
 * @return void
 */

 $errataCorrigeStorageLib = new errataCorrigeStorageLib();



$basePath = '../storage/';
$file1 = $_FILES['fileset'];
if (isset($_REQUEST['FILENAMESTORAGE'])){$FILENAMESTORAGE=$_REQUEST['FILENAMESTORAGE'];};
if (isset($_REQUEST['FOLDER'])){$FOLDER=$_REQUEST['FOLDER'];};
if (isset($_REQUEST['APPID'])){$APPID=$_REQUEST['APPID'];};
if (isset($_REQUEST['UTENTE'])){$UTENTE=$_REQUEST['UTENTE'];};
if (isset($_REQUEST['CATALOGO'])){$CATALOGO=$_REQUEST['CATALOGO'];};
if (isset($_REQUEST['ID_CATALOGO'])){$ID_CATALOGO=$_REQUEST['ID_CATALOGO'];};
if (isset($_REQUEST['PROGETTO'])){$PROGETTO=$_REQUEST['PROGETTO'];};
if (isset($_REQUEST['LINGUA'])){$LINGUA=$_REQUEST['LINGUA'];};
if (isset($_REQUEST['ID_PERIFERICA'])){$ID_PERIFERICA=$_REQUEST['ID_PERIFERICA'];};
if (isset($_REQUEST['NOTA'])){$NOTA=$_REQUEST['NOTA'];}else{$NOTA="";};

if ($file1['error']==0) {

    $ECParam = array(
        "APPID" => $APPID,
            "UTENTE" => $UTENTE,
            "CATALOGO" => $CATALOGO,
            "ID_CATALOGO" => $ID_CATALOGO,
            "PROGETTO" => $PROGETTO,  
            "FOLDER" => $FOLDER,
            "LINGUA" => $LINGUA,
            "ID_PERIFERICA" => $ID_PERIFERICA,
            "NOTA" =>$NOTA

    );  
    $pathname=$basePath.$FOLDER."/".$FILENAMESTORAGE;
    $checkupload = move_uploaded_file($file1['tmp_name'],$pathname);

    $fileArr = split_pdf($pathname, $basePath.$FOLDER);

    $countEC = 0;
    $result = false;
    foreach($fileArr as $filename)
    {

        $result = $errataCorrigeStorageLib->writeEC2($ECParam,$filename);
        if($result) {
            $countEC ++;
        }else
        {
            break;
        }
        
    }

    if($result) {
        echo json_encode("200|$countEC");
    }
    else
    {
        echo json_encode("E114");
    } 

} 




    
  
function split_pdf(string $filename, string $directory)
{
    $pdf = new Fpdi();
    $pageCount = $pdf->setSourceFile($filename);
    $file = pathinfo($filename, PATHINFO_FILENAME);
    $arrFilePage = array();
    // Split each page into a new PDF
    for ($i = 1; $i <= $pageCount; $i++) {
        $t = time();
        $newPdf = new Fpdi();
     //   $newPdf->addPage();
        $newPdf->setSourceFile($filename);
     //   $newPdf->useTemplate($newPdf->importPage($i));
     $templateId = $newPdf->importPage($i);
     // get the size of the imported page
     $size = $newPdf->getTemplateSize($templateId);
      
     // create a page (landscape or portrait depending on the imported page size)
     if ($size['width'] > $size['height']) {
         $newPdf->AddPage('L', array($size['width'], $size['height']));
     } else {
         $newPdf->AddPage('P', array($size['width'], $size['height']));
     }
 
     // use the imported page
     $newPdf->useTemplate($templateId);

        $newFilename = sprintf('%s/%s_%s_%s.pdf', $directory, $file, $i,$t);
        $fileNamePerArray = sprintf('%s_%s_%s.pdf', $file, $i,$t);
        $newPdf->output($newFilename, 'F');
        array_push($arrFilePage,$fileNamePerArray);
    }

    unlink($filename);
    return $arrFilePage;
}
